
class Cclass;

typedef struct {
	u2T				m_access;
	Cclass			*m_innerclassP;
} innerclassT;

class Cclass : public Centity {
public:
	static Cclass	*g_hash[HASHSIZE];

	Cclass			*m_hashP;
	u2T				*m_nameP;
	u2T				m_major_version;
	u2T				m_minor_version;
	u2T				m_access_flags;
	Cclass			*m_extendsP;
	int				m_implements_cnt;
	Cclass			**m_implementsPP;
	int				m_innerclasses_cnt;
	innerclassT		*m_innerclassesP;
	Cclass			*m_arrayofP;
	int				m_lineno;
	int				m_dimensions;
	int				m_processed;

	static u4T		hash(const u2T *nameP);
	static Cclass	*locate(u2T *nameP);
	static Cclass	*locate(u2T *nameP, int dimensions, int datatype);


	Cclass(const u2T *nameP, int dimensions);
	void			set_parent(Centity *parentP);

	const char 		*get_type(void) const;

	virtual objectE	type(void) const;
	virtual void	emit_id(void) const;

	void			emit_instance(void) const;
	virtual void	emit_edges(void);
	virtual void	emit_attributes(void) const;
};

